diff --git a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedFromMarkersImageFilter.hxx b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedFromMarkersImageFilter.hxx
index 51f99e5825..32da4249e9 100644
--- a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedFromMarkersImageFilter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedFromMarkersImageFilter.hxx
@@ -33,59 +33,52 @@
 namespace itk
 {
 
-template< typename TInputImage, typename TLabelImage >
-MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
-::MorphologicalWatershedFromMarkersImageFilter():
-  m_FullyConnected( false ),
-  m_MarkWatershedLine( true )
+template <typename TInputImage, typename TLabelImage>
+MorphologicalWatershedFromMarkersImageFilter<TInputImage, TLabelImage>::MorphologicalWatershedFromMarkersImageFilter()
+
 
 {
   this->SetNumberOfRequiredInputs(2);
 }
 
 
-template< typename TInputImage, typename TLabelImage >
+template <typename TInputImage, typename TLabelImage>
 void
-MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
-::GenerateInputRequestedRegion()
+MorphologicalWatershedFromMarkersImageFilter<TInputImage, TLabelImage>::GenerateInputRequestedRegion()
 {
   // call the superclass' implementation of this method
   Superclass::GenerateInputRequestedRegion();
 
   // get pointers to the inputs
-  LabelImageType * marker =
-    const_cast< LabelImageType * >( this->GetMarkerImage() );
+  auto * marker = const_cast<LabelImageType *>(this->GetMarkerImage());
 
-  InputImageType * input =
-    const_cast< InputImageType * >( this->GetInput() );
+  auto * input = const_cast<InputImageType *>(this->GetInput());
 
-  if ( !marker || !input )
-    {
+  if (!marker || !input)
+  {
     return;
-    }
+  }
 
   // We need to
   // configure the inputs such that all the data is available.
   //
-  marker->SetRequestedRegion( marker->GetLargestPossibleRegion() );
-  input->SetRequestedRegion( input->GetLargestPossibleRegion() );
+  marker->SetRequestedRegion(marker->GetLargestPossibleRegion());
+  input->SetRequestedRegion(input->GetLargestPossibleRegion());
 }
 
 
-template< typename TInputImage, typename TLabelImage >
+template <typename TInputImage, typename TLabelImage>
 void
-MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
-::EnlargeOutputRequestedRegion(DataObject *)
+MorphologicalWatershedFromMarkersImageFilter<TInputImage, TLabelImage>::EnlargeOutputRequestedRegion(DataObject *)
 {
   LabelImageType * output = this->GetOutput();
-  output->SetRequestedRegion( output->GetLargestPossibleRegion() );
+  output->SetRequestedRegion(output->GetLargestPossibleRegion());
 }
 
 
-template< typename TInputImage, typename TLabelImage >
+template <typename TInputImage, typename TLabelImage>
 void
-MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
-::GenerateData()
+MorphologicalWatershedFromMarkersImageFilter<TInputImage, TLabelImage>::GenerateData()
 {
   // there is 2 possible cases: with or without watershed lines.
   // the algorithm with watershed lines is from Meyer
@@ -99,17 +92,15 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
   //---------------------------------------------------------------------------
 
   // the label used to find background in the marker image
-  static const LabelImagePixelType bgLabel =
-    NumericTraits< LabelImagePixelType >::ZeroValue();
+  static const LabelImagePixelType bgLabel = NumericTraits<LabelImagePixelType>::ZeroValue();
   // the label used to mark the watershed line in the output image
-  static const LabelImagePixelType wsLabel =
-    NumericTraits< LabelImagePixelType >::ZeroValue();
+  static const LabelImagePixelType wsLabel = NumericTraits<LabelImagePixelType>::ZeroValue();
 
   this->AllocateOutputs();
 
   const LabelImageType * markerImage = this->GetMarkerImage();
   const InputImageType * inputImage = this->GetInput();
-  LabelImageType * outputImage = this->GetOutput();
+  LabelImageType *       outputImage = this->GetOutput();
 
   // Set up the progress reporter
   // we can't found the exact number of pixel to process in the 2nd pass, so we
@@ -117,58 +108,55 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
   ProgressReporter progress(this, 0, markerImage->GetRequestedRegion().GetNumberOfPixels() * 2);
 
   // mask and marker must have the same size
-  if ( markerImage->GetRequestedRegion().GetSize() != inputImage->GetRequestedRegion().GetSize() )
-    {
+  if (markerImage->GetRequestedRegion().GetSize() != inputImage->GetRequestedRegion().GetSize())
+  {
     itkExceptionMacro(<< "Marker and input must have the same size.");
-    }
+  }
 
   // FAH (in french: File d'Attente Hierarchique)
-  typedef std::queue< IndexType >                    QueueType;
-  typedef std::map< InputImagePixelType, QueueType > MapType;
+  using QueueType = std::queue<IndexType>;
+  using MapType = std::map<InputImagePixelType, QueueType>;
   MapType fah;
 
   // the radius which will be used for all the shaped iterators
-  Size< ImageDimension > radius;
+  Size<ImageDimension> radius;
   radius.Fill(1);
 
   // iterator for the marker image
-  typedef ConstShapedNeighborhoodIterator< LabelImageType > MarkerIteratorType;
+  using MarkerIteratorType = ConstShapedNeighborhoodIterator<LabelImageType>;
   typename MarkerIteratorType::ConstIterator nmIt;
-  MarkerIteratorType
-  markerIt( radius, markerImage, markerImage->GetRequestedRegion() );
+  MarkerIteratorType                         markerIt(radius, markerImage, markerImage->GetRequestedRegion());
   // add a boundary constant to avoid adding pixels on the border in the fah
-  ConstantBoundaryCondition< LabelImageType > lcbc;
-  lcbc.SetConstant( NumericTraits< LabelImagePixelType >::max() );
+  ConstantBoundaryCondition<LabelImageType> lcbc;
+  lcbc.SetConstant(NumericTraits<LabelImagePixelType>::max());
   markerIt.OverrideBoundaryCondition(&lcbc);
   setConnectivity(&markerIt, m_FullyConnected);
 
   // iterator for the input image
-  typedef ConstShapedNeighborhoodIterator< InputImageType > InputIteratorType;
-  InputIteratorType
-  inputIt( radius, inputImage, inputImage->GetRequestedRegion() );
+  using InputIteratorType = ConstShapedNeighborhoodIterator<InputImageType>;
+  InputIteratorType                         inputIt(radius, inputImage, inputImage->GetRequestedRegion());
   typename InputIteratorType::ConstIterator niIt;
   setConnectivity(&inputIt, m_FullyConnected);
 
   // iterator for the output image
-  typedef ShapedNeighborhoodIterator< LabelImageType > OutputIteratorType;
-  typedef typename OutputIteratorType::OffsetType      OffsetType;
+  using OutputIteratorType = ShapedNeighborhoodIterator<LabelImageType>;
+  using OffsetType = typename OutputIteratorType::OffsetType;
   typename OutputIteratorType::Iterator noIt;
-  OutputIteratorType
-  outputIt( radius, outputImage, outputImage->GetRequestedRegion() );
+  OutputIteratorType                    outputIt(radius, outputImage, outputImage->GetRequestedRegion());
   setConnectivity(&outputIt, m_FullyConnected);
 
   //---------------------------------------------------------------------------
   // Meyer's algorithm
   //---------------------------------------------------------------------------
-  if ( m_MarkWatershedLine )
-    {
+  if (m_MarkWatershedLine)
+  {
     // first stage:
     //  - set markers pixels to already processed status
     //  - copy markers pixels to output image
     //  - init FAH with indexes of background pixels with marker pixel(s) in
     //    their neighborhood
 
-    ConstantBoundaryCondition< LabelImageType > lcbc2;
+    ConstantBoundaryCondition<LabelImageType> lcbc2;
     // outside pixel are watershed so they won't be use to find real watershed
     // pixels
     lcbc2.SetConstant(wsLabel);
@@ -176,18 +164,17 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
 
     // create a temporary image to store the state of each pixel (processed or
     // not)
-    typedef Image< bool, ImageDimension > StatusImageType;
+    using StatusImageType = Image<bool, ImageDimension>;
     typename StatusImageType::Pointer statusImage = StatusImageType::New();
-    statusImage->SetRegions( markerImage->GetLargestPossibleRegion() );
+    statusImage->SetRegions(markerImage->GetLargestPossibleRegion());
     statusImage->Allocate();
 
     // iterator for the status image
-    typedef ShapedNeighborhoodIterator< StatusImageType > StatusIteratorType;
-    typename StatusIteratorType::Iterator nsIt;
-    StatusIteratorType
-                                                 statusIt( radius, statusImage, outputImage->GetRequestedRegion() );
-    ConstantBoundaryCondition< StatusImageType > bcbc;
-    bcbc.SetConstant(true);    // outside pixel are already processed
+    using StatusIteratorType = ShapedNeighborhoodIterator<StatusImageType>;
+    typename StatusIteratorType::Iterator      nsIt;
+    StatusIteratorType                         statusIt(radius, statusImage, outputImage->GetRequestedRegion());
+    ConstantBoundaryCondition<StatusImageType> bcbc;
+    bcbc.SetConstant(true); // outside pixel are already processed
     statusIt.OverrideBoundaryCondition(&bcbc);
     setConnectivity(&statusIt, m_FullyConnected);
 
@@ -198,13 +185,12 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
     // the overhead should be small
     statusImage->FillBuffer(false);
 
-    for ( markerIt.GoToBegin(), statusIt.GoToBegin(), outputIt.GoToBegin(), inputIt.GoToBegin();
-          !markerIt.IsAtEnd();
-          ++markerIt, ++outputIt )
-      {
+    for (markerIt.GoToBegin(), statusIt.GoToBegin(), outputIt.GoToBegin(), inputIt.GoToBegin(); !markerIt.IsAtEnd();
+         ++markerIt, ++outputIt)
+    {
       LabelImagePixelType markerPixel = markerIt.GetCenterPixel();
-      if ( markerPixel != bgLabel )
-        {
+      if (markerPixel != bgLabel)
+      {
         IndexType idx = markerIt.GetIndex();
 
         // move the iterators to the right place
@@ -222,36 +208,34 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
         progress.CompletedPixel();
 
         // search the background pixels in the neighborhood
-        for ( nmIt = markerIt.Begin(), nsIt = statusIt.Begin(), niIt = inputIt.Begin();
-              nmIt != markerIt.End();
-              nmIt++, nsIt++, niIt++ )
+        for (nmIt = markerIt.Begin(), nsIt = statusIt.Begin(), niIt = inputIt.Begin(); nmIt != markerIt.End();
+             nmIt++, nsIt++, niIt++)
+        {
+          if (!nsIt.Get() && nmIt.Get() == bgLabel)
           {
-          if ( !nsIt.Get() && nmIt.Get() == bgLabel )
-            {
             // this neighbor is a background pixel and is not already
             // processed; add its index to fah
-            fah[niIt.Get()].push( markerIt.GetIndex()
-                                  + nmIt.GetNeighborhoodOffset() );
+            fah[niIt.Get()].push(markerIt.GetIndex() + nmIt.GetNeighborhoodOffset());
             // mark it as already in the fah to avoid adding it several times
             nsIt.Set(true);
-            }
           }
         }
+      }
       else
-        {
+      {
         // Some pixels may be never processed so, by default, non marked pixels
         // must be marked as watershed
         outputIt.SetCenterPixel(wsLabel);
-        }
+      }
       // one more pixel done in the init stage
       progress.CompletedPixel();
-      }
+    }
     // fill the borders of the status image with "true"
-    //FillSides<StatusImageType>(statusImage, true);
+    // FillSides<StatusImageType>(statusImage, true);
     // Now disable the boundary checks
-    //outputIt.NeedToUseBoundaryConditionOff();
-    //statusIt.NeedToUseBoundaryConditionOff();
-    //inputIt.NeedToUseBoundaryConditionOff();
+    // outputIt.NeedToUseBoundaryConditionOff();
+    // statusIt.NeedToUseBoundaryConditionOff();
+    // inputIt.NeedToUseBoundaryConditionOff();
     // end of init stage
 
     // flooding
@@ -261,16 +245,16 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
     inputIt.GoToBegin();
 
     // and start flooding
-    while ( !fah.empty() )
-      {
+    while (!fah.empty())
+    {
       // store the current vars
       InputImagePixelType currentValue = fah.begin()->first;
       QueueType           currentQueue = fah.begin()->second;
       // and remove them from the fah
-      fah.erase( fah.begin() );
+      fah.erase(fah.begin());
 
-      while ( !currentQueue.empty() )
-        {
+      while (!currentQueue.empty())
+      {
         IndexType idx = currentQueue.front();
         currentQueue.pop();
 
@@ -284,77 +268,73 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
         // that value to the pixel, else keep it as is (watershed line)
         LabelImagePixelType marker = wsLabel;
         bool                collision = false;
-        for ( noIt = outputIt.Begin(); noIt != outputIt.End(); noIt++ )
-          {
+        for (noIt = outputIt.Begin(); noIt != outputIt.End(); noIt++)
+        {
           LabelImagePixelType o = noIt.Get();
-          if ( o != wsLabel )
+          if (o != wsLabel)
+          {
+            if (marker != wsLabel && o != marker)
             {
-            if ( marker != wsLabel && o != marker )
-              {
               collision = true;
               break;
-              }
+            }
             else
-                  { marker = o; }
+            {
+              marker = o;
             }
           }
-        if ( !collision )
-          {
+        }
+        if (!collision)
+        {
           // set the marker value
           outputIt.SetCenterPixel(marker);
           // and propagate to the neighbors
-          for ( niIt = inputIt.Begin(), nsIt = statusIt.Begin();
-                niIt != inputIt.End();
-                niIt++, nsIt++ )
+          for (niIt = inputIt.Begin(), nsIt = statusIt.Begin(); niIt != inputIt.End(); niIt++, nsIt++)
+          {
+            if (!nsIt.Get())
             {
-            if ( !nsIt.Get() )
-              {
               // the pixel is not yet processed. add it to the fah
               InputImagePixelType GrayVal = niIt.Get();
-              if ( GrayVal <= currentValue )
-                {
-                currentQueue.push( inputIt.GetIndex()
-                                   + niIt.GetNeighborhoodOffset() );
-                }
+              if (GrayVal <= currentValue)
+              {
+                currentQueue.push(inputIt.GetIndex() + niIt.GetNeighborhoodOffset());
+              }
               else
-                {
-                fah[GrayVal].push( inputIt.GetIndex()
-                                   + niIt.GetNeighborhoodOffset() );
-                }
+              {
+                fah[GrayVal].push(inputIt.GetIndex() + niIt.GetNeighborhoodOffset());
+              }
               // mark it as already in the fah
               nsIt.Set(true);
-              }
             }
           }
+        }
         // one more pixel in the flooding stage
         progress.CompletedPixel();
-        }
       }
     }
+  }
 
   //---------------------------------------------------------------------------
   // Beucher's algorithm
   //---------------------------------------------------------------------------
   else
-    {
+  {
     // first stage:
     //  - copy markers pixels to output image
     //  - init FAH with indexes of pixels with background pixel in their
     //    neighborhood
 
-    ConstantBoundaryCondition< LabelImageType > lcbc2;
+    ConstantBoundaryCondition<LabelImageType> lcbc2;
     // outside pixel are watershed so they won't be use to find real watershed
     // pixels
-    lcbc2.SetConstant( NumericTraits< LabelImagePixelType >::max() );
+    lcbc2.SetConstant(NumericTraits<LabelImagePixelType>::max());
     outputIt.OverrideBoundaryCondition(&lcbc2);
 
-    for ( markerIt.GoToBegin(), outputIt.GoToBegin(), inputIt.GoToBegin();
-          !markerIt.IsAtEnd();
-          ++markerIt, ++outputIt )
-      {
+    for (markerIt.GoToBegin(), outputIt.GoToBegin(), inputIt.GoToBegin(); !markerIt.IsAtEnd(); ++markerIt, ++outputIt)
+    {
       LabelImagePixelType markerPixel = markerIt.GetCenterPixel();
-      if ( markerPixel != bgLabel )
-        {
+      if (markerPixel != bgLabel)
+      {
         IndexType  idx = markerIt.GetIndex();
         OffsetType shift = idx - inputIt.GetIndex();
         inputIt += shift;
@@ -364,32 +344,32 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
         outputIt.SetCenterPixel(markerPixel);
         // search if it has background pixel in its neighborhood
         bool haveBgNeighbor = false;
-        for ( nmIt = markerIt.Begin(); nmIt != markerIt.End(); nmIt++ )
+        for (nmIt = markerIt.Begin(); nmIt != markerIt.End(); nmIt++)
+        {
+          if (nmIt.Get() == bgLabel)
           {
-          if ( nmIt.Get() == bgLabel )
-            {
             haveBgNeighbor = true;
             break;
-            }
           }
-        if ( haveBgNeighbor )
-          {
+        }
+        if (haveBgNeighbor)
+        {
           // there is a background pixel in the neighborhood; add to fah
-          fah[inputIt.GetCenterPixel()].push( markerIt.GetIndex() );
-          }
+          fah[inputIt.GetCenterPixel()].push(markerIt.GetIndex());
+        }
         else
-          {
+        {
           // increase progress because this pixel will not be used in the
           // flooding stage.
           progress.CompletedPixel();
-          }
         }
+      }
       else
-        {
+      {
         outputIt.SetCenterPixel(wsLabel);
-        }
-      progress.CompletedPixel();
       }
+      progress.CompletedPixel();
+    }
     // end of init stage
 
     // flooding
@@ -398,16 +378,16 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
     inputIt.GoToBegin();
 
     // and start flooding
-    while ( !fah.empty() )
-      {
+    while (!fah.empty())
+    {
       // store the current vars
       InputImagePixelType currentValue = fah.begin()->first;
       QueueType           currentQueue = fah.begin()->second;
       // and remove them from the fah
-      fah.erase( fah.begin() );
+      fah.erase(fah.begin());
 
-      while ( !currentQueue.empty() )
-        {
+      while (!currentQueue.empty())
+      {
         IndexType idx = currentQueue.front();
         currentQueue.pop();
 
@@ -419,44 +399,40 @@ MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
         LabelImagePixelType currentMarker = outputIt.GetCenterPixel();
         // get the current value of the pixel
         // iterate over neighbors to propagate the marker
-        for ( noIt = outputIt.Begin(), niIt = inputIt.Begin();
-              noIt != outputIt.End();
-              noIt++, niIt++ )
+        for (noIt = outputIt.Begin(), niIt = inputIt.Begin(); noIt != outputIt.End(); noIt++, niIt++)
+        {
+          if (noIt.Get() == wsLabel)
           {
-          if ( noIt.Get() == wsLabel )
-            {
             // the pixel is not yet processed. It can be labeled with the
             // current label
             noIt.Set(currentMarker);
             InputImagePixelType GrayVal = niIt.Get();
-            if ( GrayVal <= currentValue )
-              {
-              currentQueue.push( inputIt.GetIndex()
-                                 + noIt.GetNeighborhoodOffset() );
-              }
+            if (GrayVal <= currentValue)
+            {
+              currentQueue.push(inputIt.GetIndex() + noIt.GetNeighborhoodOffset());
+            }
             else
-              {
-              fah[GrayVal].push( inputIt.GetIndex()
-                                 + noIt.GetNeighborhoodOffset() );
-              }
-            progress.CompletedPixel();
+            {
+              fah[GrayVal].push(inputIt.GetIndex() + noIt.GetNeighborhoodOffset());
             }
+            progress.CompletedPixel();
           }
         }
       }
     }
+  }
 }
 
 
-template< typename TInputImage, typename TLabelImage >
+template <typename TInputImage, typename TLabelImage>
 void
-MorphologicalWatershedFromMarkersImageFilter< TInputImage, TLabelImage >
-::PrintSelf(std::ostream & os, Indent indent) const
+MorphologicalWatershedFromMarkersImageFilter<TInputImage, TLabelImage>::PrintSelf(std::ostream & os,
+                                                                                  Indent         indent) const
 {
   Superclass::PrintSelf(os, indent);
 
-  os << indent << "FullyConnected: "  << m_FullyConnected << std::endl;
-  os << indent << "MarkWatershedLine: "  << m_MarkWatershedLine << std::endl;
+  os << indent << "FullyConnected: " << m_FullyConnected << std::endl;
+  os << indent << "MarkWatershedLine: " << m_MarkWatershedLine << std::endl;
 }
 
 } // end namespace itk
diff --git a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.h b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.h
index 50f171171d..3477b72ec0 100644
--- a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.h
+++ b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.h
@@ -23,7 +23,7 @@
 namespace itk
 {
 /** \class MorphologicalWatershedImageFilter
- * \brief Watershed segmentation implementation with morphogical operators
+ * \brief Watershed segmentation implementation with morphological operators
  *
  * Watershed pixel are labeled 0.
  * TOutputImage should be an integer type.
@@ -47,35 +47,38 @@ namespace itk
  * \sa WatershedImageFilter, MorphologicalWatershedFromMarkersImageFilter
  * \ingroup ImageEnhancement  MathematicalMorphologyImageFilters
  * \ingroup ITKWatersheds
+ *
+ * \sphinx
+ * \sphinexample{Segmentation/Watersheds/MorphologicalWatershedSegmentation,Morphological Watershed Segmentation}
+ * \endsphinx
  */
-template< typename TInputImage, typename TOutputImage >
-class ITK_TEMPLATE_EXPORT MorphologicalWatershedImageFilter:
-  public ImageToImageFilter< TInputImage, TOutputImage >
+template <typename TInputImage, typename TOutputImage>
+class ITK_TEMPLATE_EXPORT MorphologicalWatershedImageFilter : public ImageToImageFilter<TInputImage, TOutputImage>
 {
 public:
-  /** Standard class typedefs. */
-  typedef MorphologicalWatershedImageFilter               Self;
-  typedef ImageToImageFilter< TInputImage, TOutputImage > Superclass;
-  typedef SmartPointer< Self >                            Pointer;
-  typedef SmartPointer< const Self >                      ConstPointer;
-
-  /** Some convenient typedefs. */
-  typedef TInputImage                            InputImageType;
-  typedef TOutputImage                           OutputImageType;
-  typedef typename InputImageType::Pointer       InputImagePointer;
-  typedef typename InputImageType::ConstPointer  InputImageConstPointer;
-  typedef typename InputImageType::RegionType    InputImageRegionType;
-  typedef typename InputImageType::PixelType     InputImagePixelType;
-  typedef typename OutputImageType::Pointer      OutputImagePointer;
-  typedef typename OutputImageType::ConstPointer OutputImageConstPointer;
-  typedef typename OutputImageType::RegionType   OutputImageRegionType;
-  typedef typename OutputImageType::PixelType    OutputImagePixelType;
+  ITK_DISALLOW_COPY_AND_ASSIGN(MorphologicalWatershedImageFilter);
+
+  /** Standard class type aliases. */
+  using Self = MorphologicalWatershedImageFilter;
+  using Superclass = ImageToImageFilter<TInputImage, TOutputImage>;
+  using Pointer = SmartPointer<Self>;
+  using ConstPointer = SmartPointer<const Self>;
+
+  /** Some convenient type alias. */
+  using InputImageType = TInputImage;
+  using OutputImageType = TOutputImage;
+  using InputImagePointer = typename InputImageType::Pointer;
+  using InputImageConstPointer = typename InputImageType::ConstPointer;
+  using InputImageRegionType = typename InputImageType::RegionType;
+  using InputImagePixelType = typename InputImageType::PixelType;
+  using OutputImagePointer = typename OutputImageType::Pointer;
+  using OutputImageConstPointer = typename OutputImageType::ConstPointer;
+  using OutputImageRegionType = typename OutputImageType::RegionType;
+  using OutputImagePixelType = typename OutputImageType::PixelType;
 
   /** ImageDimension constants */
-  itkStaticConstMacro(InputImageDimension, unsigned int,
-                      TInputImage::ImageDimension);
-  itkStaticConstMacro(OutputImageDimension, unsigned int,
-                      TOutputImage::ImageDimension);
+  static constexpr unsigned int InputImageDimension = TInputImage::ImageDimension;
+  static constexpr unsigned int OutputImageDimension = TOutputImage::ImageDimension;
 
   /** Standard New method. */
   itkNewMacro(Self);
@@ -109,34 +112,36 @@ public:
 
 protected:
   MorphologicalWatershedImageFilter();
-  ~MorphologicalWatershedImageFilter() ITK_OVERRIDE {}
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
+  ~MorphologicalWatershedImageFilter() override = default;
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
 
   /** MorphologicalWatershedImageFilter needs the entire input be
    * available. Thus, it needs to provide an implementation of
    * GenerateInputRequestedRegion(). */
-  void GenerateInputRequestedRegion() ITK_OVERRIDE;
+  void
+  GenerateInputRequestedRegion() override;
 
   /** MorphologicalWatershedImageFilter will produce the entire output. */
-  void EnlargeOutputRequestedRegion( DataObject *itkNotUsed(output) ) ITK_OVERRIDE;
+  void
+  EnlargeOutputRequestedRegion(DataObject * itkNotUsed(output)) override;
 
   /** Single-threaded version of GenerateData.  This filter delegates
    * to GrayscaleGeodesicErodeImageFilter. */
-  void GenerateData() ITK_OVERRIDE;
+  void
+  GenerateData() override;
 
 private:
-  ITK_DISALLOW_COPY_AND_ASSIGN(MorphologicalWatershedImageFilter);
-
-  bool m_FullyConnected;
+  bool m_FullyConnected{ false };
 
-  bool m_MarkWatershedLine;
+  bool m_MarkWatershedLine{ true };
 
   InputImagePixelType m_Level;
 }; // end of class
 } // end namespace itk
 
 #ifndef ITK_MANUAL_INSTANTIATION
-#include "itkMorphologicalWatershedImageFilter.hxx"
+#  include "itkMorphologicalWatershedImageFilter.hxx"
 #endif
 
 #endif
